import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { CnSLB } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-12-20 15:26
 */
interface CnSLBCU extends ConditionUtil<CnSLBCU>{
    ID:FieldUtil<CnSLBCU>;
    NAME:FieldUtil<CnSLBCU>;
    SLB_ID:FieldUtil<CnSLBCU>;
    TYPE:FieldUtil<CnSLBCU>;
    SERVICE_IP:FieldUtil<CnSLBCU>;
    CONFIGURATION:FieldUtil<CnSLBCU>;
    DELETED:FieldUtil<CnSLBCU>;
    CREATE_USER_ID:FieldUtil<CnSLBCU>;
    CREATE_TIME:FieldUtil<CnSLBCU>;
    UPDATE_USER_ID:FieldUtil<CnSLBCU>;
    UPDATE_TIME:FieldUtil<CnSLBCU>;
    CLOUD_PROVIDER:FieldUtil<CnSLBCU>;
    URL:FieldUtil<CnSLBCU>;
}

class CnSLBCUImpl extends ConditionUtilImpl<CnSLBCUImpl> implements CnSLBCU{ 
    newInstance(): CnSLBCUImpl {
        return new CnSLBCUImpl();
    } 
    get ID(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get NAME(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('name','name','名称', this);
    }
    get SLB_ID(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('slb_id','slbId','SLB主键id', this);
    }
    get TYPE(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('type','type','0：内网，1：外网', this);
    }
    get SERVICE_IP(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('service_ip','serviceIp','服务地址', this);
    }
    get CONFIGURATION(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('configuration','configuration','配置信息', this);
    }
    get DELETED(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('deleted','deleted','删除标记', this);
    }
    get CREATE_USER_ID(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('create_user_id','createUserId','创建人', this);
    }
    get CREATE_TIME(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('create_time','createTime','创建时间', this);
    }
    get UPDATE_USER_ID(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('update_user_id','updateUserId','更新人', this);
    }
    get UPDATE_TIME(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('update_time','updateTime','更新时间', this);
    }
    get CLOUD_PROVIDER(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('cloud_provider','cloudProvider','0:阿里云,1:华为云', this);
    }
    get URL(): FieldUtil<CnSLBCU>{  
        return new FieldUtil('url','url','SLB URL', this);
    }
}

@Singleton 
class CnSLBMU extends TableUtilImpl<CnSLBCU,CnSLB>{ 
    tableName  = 'cn_slb';
    tableFields  = ['id','name','slb_id','type','service_ip','configuration','deleted','create_user_id','create_time','update_user_id','update_time','cloud_provider','url'];
    modelFields  = ['id','name','slbId','type','serviceIp','configuration','deleted','createUserId','createTime','updateUserId','updateTime','cloudProvider','url'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): CnSLBCU {
        return new CnSLBCUImpl();
    }   

    static get ID(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('id','id','主键', new CnSLBCUImpl());
    }
    static get NAME(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('name','name','名称', new CnSLBCUImpl());
    }
    static get SLB_ID(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('slb_id','slbId','SLB主键id', new CnSLBCUImpl());
    }
    static get TYPE(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('type','type','0：内网，1：外网', new CnSLBCUImpl());
    }
    static get SERVICE_IP(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('service_ip','serviceIp','服务地址', new CnSLBCUImpl());
    }
    static get CONFIGURATION(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('configuration','configuration','配置信息', new CnSLBCUImpl());
    }
    static get DELETED(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('deleted','deleted','删除标记', new CnSLBCUImpl());
    }
    static get CREATE_USER_ID(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('create_user_id','createUserId','创建人', new CnSLBCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('create_time','createTime','创建时间', new CnSLBCUImpl());
    }
    static get UPDATE_USER_ID(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('update_user_id','updateUserId','更新人', new CnSLBCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('update_time','updateTime','更新时间', new CnSLBCUImpl());
    }
    static get CLOUD_PROVIDER(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('cloud_provider','cloudProvider','0:阿里云,1:华为云', new CnSLBCUImpl());
    }
    static get URL(): FieldUtil<CnSLBCU>{ 
        return new FieldUtil('url','url','SLB URL', new CnSLBCUImpl());
    }

    get ID(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.ID;
    }
    get NAME(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.NAME;
    }
    get SLB_ID(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.SLB_ID;
    }
    get TYPE(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.TYPE;
    }
    get SERVICE_IP(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.SERVICE_IP;
    }
    get CONFIGURATION(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.CONFIGURATION;
    }
    get DELETED(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.DELETED;
    }
    get CREATE_USER_ID(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.CREATE_USER_ID;
    }
    get CREATE_TIME(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.CREATE_TIME;
    }
    get UPDATE_USER_ID(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.UPDATE_USER_ID;
    }
    get UPDATE_TIME(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.UPDATE_TIME;
    }
    get CLOUD_PROVIDER(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.CLOUD_PROVIDER;
    }
    get URL(): FieldUtil<CnSLBCU>{ 
        return CnSLBMU.URL;
    }
}
export {CnSLBMU, CnSLBCU}
